# -*- coding: utf-8 -*-

from __future__ import generators
__doc__ = """\
Project:    Python Find
Version:    $Id: filewrapper.py 29 2006-06-10 12:08:45Z ns $
Licence:    GPL
Start:      Sat Jun  5 09:42:53 MSD 2004
Title:      Python Find / File Wrapper
Author:     
    Andrey Orlov (c) 2004
        
Description:     

    Find provide a way to treatment file hierarhies and file sequence with
    some conditional return.

Warranty:

    There is no warranty of any kind, either expressed
    or implied
                        
TODO:
    Nothing

"""
__version__ = '$Rev: 1.1 $'[6:-1]
# $Id: filewrapper.py 29 2006-06-10 12:08:45Z ns $
def _(s) : return s

import stat,os,sys

class FileWrapper(object) :
    def __init__(self,path,dereference=False,depth=0,**kw) :
        self.name = os.path.basename(path)
        self.path = path
        self.dereference = dereference
        self._depth=depth
        self.kw = kw.copy()
        
        if dereference :
            self.stat = os.stat(path)
        else :
            self.stat = os.lstat(path)
            
        super(FileWrapper,self).__init__(path,**kw)

    def isreg(self) :
        return stat.S_ISREG(self.stat[0])

    def isdir(self) :
        return stat.S_ISDIR(self.stat[0])

    def keys(self) :
        if not self.isdir() :
            raise OSError
            
        return os.listdir(self.path)

    def items(self) :
        return [ (item, self[item]) for item in self.keys() ]

    def values(self) :
        return [ value for key,value  in self.items() ]
        
    def has_key(self,key) :
        return os.path.exists(os.path.join(self.path,key))

    def __getitem__(self,key) :
        return self.__class__(os.path.join(self.path,key),self.dereference,depth=self._depth+1,**self.kw)
        
    def __setitem__(self,key) :
        raise OSError

    def __delitem__(self,key) :
        raise OSError
    
    def __len__(self) :
        return len(os.listdir(self.path))

    def __repr__(self) :
        return repr(self.path)
        
    def __str__(self) :
        if self.isdir() :
            return '\n---------------\n'.join([ str(x) for x in self.values()])
        else :
            try :
                return open(self.path).read()
            except (IOError,OSError) :
                return '' 
                
if __name__ == '__main__' :
    print "Lads, it's only module, don't use it as application..."
    