# -*- coding: utf-8 -*-

from __future__ import generators
__doc__ = """\
Project:    Python Find
Version:    $Id: findmixin.py 29 2006-06-10 12:08:45Z ns $
Licence:    GPL
Start:      Sat Jun  5 09:42:53 MSD 2004
Title:      Python Find / File Wrapper
Author:     
    Andrey Orlov (c) 2004
        
Description:     

    Find provide a way to treatment file hierarhies and file sequence with
    some conditional return.

Warranty:

    There is no warranty of any kind, either expressed
    or implied
                        
TODO:
    Nothing

"""
__version__ = '$Rev: 1.1 $'[6:-1]
# $Id: findmixin.py 29 2006-06-10 12:08:45Z ns $
def _(s) : return s

import stat,os
import re
import time

class FindMixIn(object) :

    def __init__(self,path,**kw) :
        super(FindMixIn,self).__init__(path,**kw)

    def __checktime_(self,t) :
        return (time.time() - self.stat[t]) / 60 / 60 /24 

    def mtime(self) :
        return self.__checktime_(stat.ST_MTIME)
        
    def atime(self) :
        return self.__checktime_(stat.ST_ATIME)
        
    def ctime(self) :
        return self.__checktime_(stat.ST_CTIME)
        
    def newer(self,path) :
        return os.stat(path)[self.ST_MTIME] > self.stat[stat.ST_MTIME]
    
    def check_name(self,name) :
        return self.name == name

    def check_path(self,path) :
        return self.path == path
        
    def check_path_regex(self,regexp) :
        return re.compile(regexp).match(self.path)

    def check_regex(self,regexp) :
        return re.compile(regexp).match(self.name)

    def check_iregex(self,regexp) :
        return re.compile(regexp,re.I).match(self.name)
        
    def depth(self) :
        return self._depth

    def dele(self) :
        os.remove(self.path)

    def execute(self,frm=None) :
        if frm is not None :
            os.system(frm.replace("{}",self.path))
            
if __name__ == '__main__' :
    print "Lads, it's only module, don't use it as application..."
    