#! /usr/bin/env python

from __future__ import generators
__doc__ = """\
Project:    rPAS 
Licence:    GPL
Start:      Mon Mar 15 00:52:16 MSK 2004
Title:      RPM Build Python  / Find Requires
Author:     
    Andrey Orlov (c) 2004
        
Description:     

    This application is intendent to extract requires for python modules.
    
Call:
    python_requires.py [<MODULE>]+

Switches:

    None

Warranty:

    There is no warranty of any kind, either expressed
    or implied
                        
TODO:
    Nothing

"""

__version__ = '$Revision: 1.1 $'[10:-1]

def _(s) : return s

import sys, os
import parser, symbol, token, types

prefix = "python%u.%u" % sys.version_info[0:2]

def getReqName(x) :
    return "%s(%s)" % (prefix,x)

symbol_skip = [symbol.encoding_decl, symbol.classdef]

# Preliminary hack to python 2.4 compatibility
def pro(x) :
    return x[1]
            
ignore = dict([ (x,1) for x in 
    list(os.getenv('RPM_PYTHON_REQ_SKIP',"").split())
    + list(sys.builtin_module_names)]).has_key

REQ = os.getenv('RPM_PYTHON_REQ_METHOD','relaxed')
IS_HIER = os.getenv('RPM_PYTHON_REQ_HIER',"hier")

def match(tree,deep=0) :
    if tree[0] not in  symbol_skip :
        deep += 1
    for node in tree :
        if type(node) in [types.ListType, types.TupleType] :
            if node[0] == symbol.import_stmt :
                if REQ not in ['slight','relaxed'] or deep == 4 :
                    node = pro(node)
                    if node[1][1] == 'import' :
                        for name in [x for x in node[2][1:] if x[0] != 12  ] :
                            if IS_HIER is None :
                                yield name[1][1][1]
                            else :
                                yield ".".join( [ i for t,i in  name[1][1:] if t==1 ])

                    elif node[1][1] == 'from' :
                        if IS_HIER is None :
                            yield node[2][1][1]
                        else :
                            yield ".".join( [ i for t,i in  node[2][1:] if t==1 ])
         
            for item in match(node,deep) :
                yield item

def requires(src,frm=getReqName) :
    try :
        lis = parser.suite(file(src).read().rstrip().replace("\r\n","\n")).tolist()
    except SyntaxError,msg :
        pass
    except :
        print >> sys.stderr, 'Error while parsing "%s"'%src
        raise
    else :
        for item in match(lis) :
            if not ignore(item) :
                yield frm(item)

def file_requires(files) :
    for src in files :
        if '.py' == os.path.splitext(os.path.basename(src))[1] :
            for item in requires(src) :
                yield (item,src)

if __name__ == '__main__' :
    import sys
    for item in file_requires(sys.argv[1:]) :
        print item
        
